import pickle, os, sys
import pandas as pd

unit_tmp = sys.argv[1]
valid_start = sys.argv[2]
valid_end = sys.argv[3]

### unit 1
if unit_tmp == "1":
    directory = f"../result_sys_valid_tp_ecmwf/unit1/cv_{valid_start}_{valid_end}/rpss_dic/"
    df_all = pd.DataFrame()
    for filename in os.listdir(directory):
        f = os.path.join(directory, filename)
        data = pickle.load(open(f, "rb"))

        file_name = f.split("/")[-1].split(".")[0]
        df = pd.DataFrame.from_dict(data, orient='index')
        df.columns = [file_name]
        df_all = pd.concat([df_all, df], axis=1)

    df_all.to_csv(f"../result_sys_valid_tp_ecmwf/unit1/cv_{valid_start}_{valid_end}/unit1.csv")

    df_all_argmax = df_all.idxmax(axis=1)
    df_all_max = df_all.max(axis=1)
    df_all_mm = pd.concat([df_all_argmax, df_all_max], axis=1)
    address = ["unit1"]*len(df_all_max)
    df_all_mm.insert(loc=0, column='A', value=address)
    df_all_mm.to_csv(f"../result_sys_valid_tp_ecmwf/unit1/cv_{valid_start}_{valid_end}/unit1_max.csv", header = False)
    
    print(">>>> Finish!!")

### unit 2, 3,...
elif (unit_tmp != "level") and (unit_tmp != "1"):
    unit_max = pd.read_csv(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp-1}/cv_{valid_start}_{valid_end}unit{unit_tmp-1}_max.csv", header=None, index_col=0)
    directory = f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/score_dict/"
    df_all = pd.DataFrame()

    if os.path.exists("../result_sys_valid_tp_ecmwf/score_set.csv"):
        df_set = pd.read_csv("../result_sys_valid_tp_ecmwf/score_set.csv", header=None, index_col=0)
    else:
        df_set = pd.DataFrame()

    for filename in os.listdir(directory):
        f = pd.read_csv(directory+filename, index_col = 0).T
        
        df_all_argmax = f.idxmax(axis=0)
        df_all_max = f.max(axis=0)

        file_name = filename.split("/")[-1].split(".")[0].split("_")[0]
        unit1 = unit_max.loc[[file_name]]
        df = pd.DataFrame([file_name, f"unit{unit_tmp}", df_all_argmax.values[0], df_all_max.values[0]])
        
        if df_all_max.values[0] <= unit1[3].values[0]:
            # a = df.T.set_index(0)
            df_set = pd.concat([df_set, unit1], axis=0)
        else:
            df_all = pd.concat([df_all, df], axis=1)

    if len(df_all) != 0:
        df_all = df_all.T.set_index(0)
        df_all.to_csv(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/unit{unit_tmp}_max.csv", header = False)
    else:
        print("No need to do more unit test!")

    if len(df_set) != 0:
        df_set.to_csv("../result_sys_valid_tp_ecmwf/score_set.csv", header = False)

    print(">>>> Finish!!")

### unit level
else:
    var_name = sys.argv[2]
    flag_pre = sys.argv[3]
    flag_var_only = int(sys.argv[3])

    root_dir = f"../result_sys_valid_tp_ecmwf/level_var/{var_name}/score_dict"

    if flag_pre == "0":
        orig_score = pd.read_csv("../result_sys_valid_tp_ecmwf/score_set.csv", header = None, index_col=0)
    else:
        orig_score = pd.read_csv(f"../result_sys_valid_tp_ecmwf/level_var/{flag_pre}_score_set.csv", header = None, index_col=0)

    df_max = pd.DataFrame()

    for filename in os.listdir(root_dir):
        tmp_dir = os.path.join(root_dir, filename)
        name = tmp_dir.split("/")[-1].split("_")[0]
        level_file = pd.read_csv(tmp_dir, header = 0, index_col=0)

        df_all_unit = f"unit_level_{var_name}"
        df_all_argmax = level_file.idxmax(axis=0).values[0]
        df_all_max = level_file.max(axis=0).values[0]
        
        orig_max = orig_score.loc[[name]][3].values[0]
        orig_file = orig_score.loc[[name]][2].values[0]
        orig_unit = orig_score.loc[[name]][1].values[0]

        if (df_all_max <= orig_max) and (flag_var_only == 0):
            df_all_max = orig_max
            df_all_argmax = orig_file
            df_all_unit = orig_unit

        region_max = pd.DataFrame([name, df_all_unit, df_all_argmax, df_all_max]).T
        df_max = pd.concat([df_max, region_max], axis=0)

    df_max = df_max.set_index(0)

    if flag_var_only == 0:
        df_max.to_csv(f"../result_sys_valid_tp_ecmwf/level_var/{var_name}_score_set.csv", header = False)
    else:
        df_max.to_csv(f"../result_sys_valid_tp_ecmwf/level_var/{var_name}_score_set_tmp.csv", header = False)

