import pickle, os, sys, re, shutil
import pandas as pd
import xarray as xr
import numpy as np
from scripts_tp import *


# var_name = sys.argv[1]

# orig_file = "../result_sys_valid_tp_ecmwf/score_set.csv"
# level_file = f"../result_sys_valid_tp_ecmwf/level_var/{var_name}_score_set.csv"

# orig_score = pd.read_csv(orig_file, header = None, index_col=0)
# level_score = pd.read_csv(level_file, header = None, index_col=0)
# new_score = pd.DataFrame()
# for i in range(len(level_score)):
#     region_info = level_score.iloc[[i]]
#     region_name = level_score.iloc[[i]].index.values[0]
#     if region_info[2].values[0].startswith("fct"):
#         new_score = pd.concat([new_score, orig_score.loc[[region_name]]])
#     else:
#         new_score = pd.concat([new_score, region_info])

# new_score.to_csv(f"../result_sys_valid_tp_ecmwf/level_var/score_summary/{var_name}_score_set_all.csv", header = False)



# ---------------------------------------------------------------------

# cache_path = "../../data/newdata"
# v = 'tp'

# ### argument
# CLS = sys.argv[1]                           ### Choose classification method. Suggestion: RF
# wk = sys.argv[2]                            ### Choose 
# var_name = sys.argv[3]

# # ------------
# time_train_start,time_train_end='2000','2018' # train

# # ------------------
# ### run week 3-4 prediction
# if wk == "w34":
#     flag_w34 = 1                            ### predict w34
#     flag_w56 = 0
#     num_indent = 4
# elif wk == "w56":
#     flag_w56 = 1                            ### predict w56
#     flag_w34 = 0
#     num_indent = 6
# else:
#     print("Wrong week index!!!")

# # --------------------------------------------
# ### train output
# try:
#     obs_2000_2019 = xr.open_dataset(f"{cache_path}/hindcast-like-observations_2000-2019_biweekly_deterministic.nc")
# except:
#     obs_2000_2019 = xr.open_zarr(f"{cache_path}/hindcast-like-observations_2000-2019_biweekly_deterministic.zarr")

# if flag_w34 == 1:
#     obs_2000_2019_w34 = obs_2000_2019.isel(lead_time=[0])
# elif flag_w56 == 1:
#     obs_2000_2019_w34 = obs_2000_2019.isel(lead_time=[1])

# # --------------------------------------------
# ### averaged removed sequences
# train_data = obs_2000_2019_w34.sel(forecast_time=slice(time_train_start, time_train_end))[v].values.transpose(1,0,2,3)
# train_data = np.mean(train_data, axis=1)
# train_avg_rm = train_data[num_indent:, :, :]

# if v == "t2m":
#     mask_flt = np.where(~np.isnan(train_avg_rm[316]))
# elif v == "tp":
#     mask_flt = np.where(~np.isnan(train_data[0]))

# ##################################################################

# df_path = f"../result_sys_valid_tp_ecmwf/test/{var_name}_2020/{var_name}_scores.csv"
# df_level = pd.read_csv(df_path, header=None, index_col=0)

# df_all_max = pd.read_csv("../result_sys_valid_tp_ecmwf/score_set.csv", header=None)
# df_all_max = df_all_max.set_index(0)

# region = pd.read_csv('../data/Regions.txt', sep=',')
# d_region = {}
# for i in range(region.shape[0]):
#     d_region[region.iloc[i]["Region"]] = d_region.get(region.iloc[i]["Region"], [])+[list(region.iloc[i, 1:])]


# df_totalloc = pd.DataFrame()
# for row in range(df_all_max.shape[0]):
#     name = df_all_max.iloc[[row]].index.values[0]   
    
#     ### get coord for each region
#     loc_region = d_region[name]
#     u1, d1, l1, r1 = loc_region[0]
#     u2, d2, l2, r2 = u1, d1, l1, r1
#     if len(loc_region) > 1:
#         u2, d2, l2, r2 = loc_region[1]

#     locs = 0
#     for idx in range(len(mask_flt[0])):
#         i = mask_flt[0][idx]
#         j = mask_flt[1][idx]  
#         if ((i>=u1) and (i<d1) and (j>=l1) and (j<r1)) or ((i>=u2) and (i<d2) and (j>=l2) and (j<r2)):
#             locs += 1

#     df_totalloc = pd.concat([df_totalloc, pd.DataFrame([name, locs]).T.set_index(0)], axis=0)

# df_merge = pd.merge(df_level, df_totalloc, left_index=True, right_index=True)
# df_merge.to_csv(f"../result_sys_valid_tp_ecmwf/test/{var_name}_2020/{var_name}_region_locs.csv", header = False)

# ##################################################################

CLS = sys.argv[1]                           ### Choose classification method. Suggestion: RF
wk = sys.argv[2]                            ### Choose 
var_name = sys.argv[3]

cache_path = "../../data/newdata"
v = 'tp'
time_train_start, time_train_end = "2000", "2018"
# ------------------
### run week 3-4 prediction
if wk == "w34":

    flag_w34 = 1                            ### predict w34
    flag_w56 = 0
    num_indent = 4
    criterion = "gini"                      ### entropy for w34, gini for w56

elif wk == "w56":

    flag_w56 = 1                            ### predict w56
    flag_w34 = 0
    num_indent = 6
    criterion = "entropy"                    ### entropy for w34, gini for w56
    
else:
    print("Wrong week index!!!")

### train output
try:
    obs_2000_2019 = xr.open_dataset(f"{cache_path}/hindcast-like-observations_2000-2019_biweekly_deterministic.nc")
except:
    obs_2000_2019 = xr.open_zarr(f"{cache_path}/hindcast-like-observations_2000-2019_biweekly_deterministic.zarr")

if flag_w34 == 1:
    obs_2000_2019_w34 = obs_2000_2019.isel(lead_time=[0])
elif flag_w56 == 1:
    obs_2000_2019_w34 = obs_2000_2019.isel(lead_time=[1])

# --------------------------------------------
### averaged removed sequences
train_data = obs_2000_2019_w34.sel(forecast_time=slice(time_train_start, time_train_end))[v].values.transpose(1,0,2,3)
train_data = np.mean(train_data, axis=1)
train_avg_rm = train_data[num_indent:, :, :]

if v == "t2m":
    mask_flt = np.where(~np.isnan(train_avg_rm[316]))
elif v == "tp":
    mask_flt = np.where(~np.isnan(train_data[0]))

val_sum_path = f"../result_sys_valid_tp_ecmwf/valid/{var_name}_2019/y_train_prob_10/"
if not os.path.exists(val_sum_path):
    os.makedirs(val_sum_path)

region = pd.read_csv('../data/Regions.txt', sep=',')
d_region = {}
for i in range(region.shape[0]):
    d_region[region.iloc[i]["Region"]] = d_region.get(region.iloc[i]["Region"], [])+[list(region.iloc[i, 1:])]

df_path = f"../result_sys_valid_tp_ecmwf/level_var/{var_name}_score_set.csv"
df_level = pd.read_csv(df_path, header=None, index_col=0)

for row in range(df_level.shape[0]):
    name = df_level.iloc[[row]].index.values[0]   
    print("!!!!", name)

    best_set_str = df_level.loc[[name]][2].values[0]
    unit_fldr = df_level.loc[[name]][1].values[0]
    level_unit = df_level.loc[[name]][1].values[0].split("_")[-1]
    
    loc_region = d_region[name]
    u1, d1, l1, r1 = loc_region[0]
    u2, d2, l2, r2 = u1, d1, l1, r1
    if len(loc_region) > 1:
        u2, d2, l2, r2 = loc_region[1]

    if unit_fldr == "unit1":
        val_path = f"../result_sys_valid_tp_ecmwf/{unit_fldr}/RegModel_RF_{criterion}_w34{flag_w34}_w56{flag_w56}_{best_set_str}/y_test_prob_10/"
    elif ("level" in unit_fldr):
        val_path = f"../result_sys_valid_tp_ecmwf/level_var/{level_unit}/{name}/RegModel_RF_{criterion}_w34{flag_w34}_w56{flag_w56}_{df_level.loc[[name]][2].values[0]}/y_test_prob_10/"
    else:
        val_path = f"../result_sys_valid_tp_ecmwf/{unit_fldr}/{name}/RegModel_RF_{criterion}_w34{flag_w34}_w56{flag_w56}_{best_set_str}/y_test_prob_10/"
    print(val_path)
    files = os.listdir(val_path)
    dest_dir = val_sum_path
    for fname in files:
        i, j = int(fname.split("by")[0].split("_")[-1]), int(fname.split("by")[1].split("_")[0])
        if ((i>=u1) and (i<d1) and (j>=l1) and (j<r1)) or ((i>=u2) and (i<d2) and (j>=l2) and (j<r2)):
            shutil.copy2(os.path.join(val_path, fname), dest_dir)